package schedframe.resources.computing.profiles.energy.thermal;

import schedframe.resources.StandardResourceType;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.profiles.energy.thermal.ui.ComputingResourceThermalInterface;
import schedframe.resources.computing.profiles.energy.thermal.ui.ThermalInterface;
import schedframe.resources.devices.PhysicalResource;
import schedframe.resources.devices.DeviceThermalInterface;

public class ThermalInterfaceFactory {
	public static ThermalInterface createThermalInterface(PhysicalResource resource, ThermalProfile tp){
		if(tp == null)
			return null;
		ThermalInterface thermalInterface;
		if (resource.getType().getName().equals(StandardResourceType.CRAH.getName()))
			thermalInterface = new DeviceThermalInterface(resource, tp);
		else if (resource.getType().getName().equals(StandardResourceType.Fan.getName()))
			thermalInterface = new DeviceThermalInterface(resource, tp);
		else if(resource.getType().getName().equals(StandardResourceType.Inlet.getName()))
			thermalInterface = new DeviceThermalInterface(resource, tp);
		else if(resource.getType().getName().equals(StandardResourceType.Outlet.getName()))
			thermalInterface = new DeviceThermalInterface(resource, tp);
		else 
			thermalInterface = new ComputingResourceThermalInterface((ComputingResource)resource, tp);
		return thermalInterface;
	}
}
